
#include <stdio.h>
#include <stdlib.h>

#ifdef	FOM
#include "sif_f.h"

#define CELL	FOM
#define EXEC	"hp2ft"
#define SIF	StoreImageFile_Float
#else
#include "cell.h"
#include "sif.h"

#define CELL	Cell
#define EXEC	"hp2it"

#define SIF(path,width,height,cell,desc)	\
	StoreImageFile(path,width,height,16,cell,desc)
#endif

static void	Error(char *M)
{
	(void)fputs(M,stderr); (void)fputc('\n',stderr); exit(1);
}

static int	GetW(FILE *F)
{
	int	l,h;

	return ((l=fgetc(F))==EOF || (h=fgetc(F))==EOF)?-1:l+(h<<8);
}

int	main(int a,char **A)
{
	FILE	*F;
	int	l,X,Y,y,x,w;
	char	*D;
	CELL	**C,*c;

	if (a!=3) Error("usage : " EXEC " HP.img HP.tif");

	if ((F=fopen(A[1],"rb"))==NULL) Error("file not open.");

	if (fgetc(F)!='I' || fgetc(F)!='M') Error("bad magic number.");

	if ((l=GetW(F))<0) Error("bad comment length.");

	if ((X=GetW(F))<=0 || (Y=GetW(F))<=0) Error("bad image size.");

	(void)fseek(F,4L,SEEK_CUR);

	if (GetW(F)!=2) Error("bad image type.");

	(void)fseek(F,50L,SEEK_CUR);

	if ((D=(char *)malloc((size_t)(l+1)))==NULL ||
	    (C=(CELL **)malloc(sizeof(CELL *)*Y))==NULL ||
	    (*C=c=(CELL *)malloc(sizeof(CELL)*Y*X))==NULL)
	    Error("memory allocation error.");

	if (fread(D,(size_t)1,(size_t)l,F)!=l) Error("comment read error.");

	D[l]='\0';

	for (y=0; y<Y; y++) {
	    if (y>0) C[y]=C[y-1]+X;

	    for (x=0; x<X; x++) {
		if ((w=GetW(F))<0) Error("image data read error.");

		*(c++)=(CELL)w;
	    }
	}
	SIF(A[2],X,Y,C,D);

	free(*C); free(C); free(D); (void)fclose(F); return 0;
}
