
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "rhp.h"
#include "sif_f.h"

extern void	Error(char *msg),
		RangeList(char *str,size_t lim,char *rl);

#define LEN	2048

int	main(int argc,char **argv)
{
	HiPic	hp;
	char	*rl;
	int	t,y,x;
	char	path[LEN];

	if (argc!=4) Error("usage : hp2xp HiPic/ rangeList XP_format");

	InitReadHiPic(argv[1],&hp);

	if ((rl=(char *)malloc(sizeof(char)*hp.Nt))==NULL)
	    Error("memory allocation error.");

	RangeList(argv[2],(size_t)hp.Nt-1,rl);

	for (t=0; t<hp.Nt; t++)
	    if (rl[t]) {
		ReadHiPic(&hp,t);

		for (y=0; y<hp.Ny; y++)
		for (x=0; x<hp.Nx; x++)
		    hp.T[y][x]=(hp.T[y][x]>0.0)?-log(hp.T[y][x]):0.0;

		(void)sprintf(path,argv[3],t);
		StoreImageFile_Float(path,hp.Nx,hp.Ny,hp.T,SIF_F_desc);

		(void)printf("%d\t%s\n",t,SIF_F_desc);
	    }

	free(rl);

	TermReadHiPic(&hp);

	return 0;
}
