
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "rhp.h"
#include "msd.h"
#include "sif_f.h"

extern void	Error(char *msg);

int	main(int argc,char **argv)
{
	HiPic	hp;
	int	y1,y2,i,Ny,Ox1,Ox2,Oy1,Oy2,X,Ox,Y,Oy,y,x;
	FOM	**fom,*F,*T,*D;
	MSD	msd;
	double	d;

	if (argc<6 || argc>9)
	Error("usage : oct_cmp_0 HiPic/ {y1 y2} Ox1 Ox2 Oy1 Oy2 {MSD.tif}");

	InitReadHiPic(argv[1],&hp);

	if (argc==6 || argc==7) {
	    y1=0; y2=hp.Ny-1; i=2;
	}
	else {
	    if ((y1=atoi(argv[2]))<0 ||
		(y2=atoi(argv[3]))>=hp.Ny || y1>y2)
		Error("bad range of slices.");

	    i=4;
	}
	Ny=y2-y1+1;
	if ((Ox1=atoi(argv[i  ]))<=(-hp.Nx) ||
	    (Ox2=atoi(argv[i+1]))>=  hp.Nx  || Ox1>Ox2 ||
	    (Oy1=atoi(argv[i+2]))<=(-   Ny) ||
	    (Oy2=atoi(argv[i+3]))>=     Ny  || Oy1>Oy2)
	    Error("bad range of offsets.");

	X=((Ox=Ox2-Ox1+1)>hp.Nx)?Ox:hp.Nx;
	Y=((Oy=Oy2-Oy1+1)>   Ny)?Oy:   Ny;
	if ((fom=(FOM **)malloc(sizeof(FOM *)*Y))==NULL ||
	    (*fom=(FOM *)malloc(sizeof(FOM)*Y*X))==NULL ||
	    !InitMSD(&msd,hp.Nx,Ny,hp.Nx,Ny,Ox1,Oy1,Ox2,Oy2))
	    Error("memory allocation error.");

	for (y=1; y<Y; y++) fom[y]=fom[y-1]+X;

	ReadHiPic(&hp,0);
	for (y=y1; y<=y2; y++) {
	    F=fom[y-y1]; T=hp.T[y];
	    for (x=0; x<hp.Nx; x++) F[x]=(T[x]>0.0)?-log(T[x]):0.0;
	}
	ReadHiPic(&hp,hp.Nt-1);
	for (y=y1; y<=y2; y++) {
	    F=hp.T[y-y1]; T=hp.T[y];
	    for (x=0; x<hp.Nx; x++) F[x]=(T[x]>0.0)?-log(T[x]):0.0;
	}
	CalcMSD(&msd,fom,hp.T);

	d=(*(D=msd.D)); X=Y=0;
	for (y=0; y<Oy; y++)
	for (x=0; x<Ox; x++) if ((fom[y][x]=(*(D++)))<d) d=fom[Y=y][X=x];

	(void)printf("%d\t%d\t%le\n",X+Ox1,Y+Oy1,d);

	if (argc==7 || argc==9)
	    StoreImageFile_Float(argv[argc-1],Ox,Oy,fom,SIF_F_desc);

	TermMSD(&msd); free(*fom); free(fom); TermReadHiPic(&hp); return 0;
}
