
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "rhp.h"
#include "msd.h"
#include "sif_f.h"

extern void	Error(char *msg);

#define LEN	2048

int	main(int argc,char **argv)
{
	HiPic	hp;
	int	y1,y2,i,Ny,Ox1,Ox2,Oy1,Oy2,X,Ox,Y,Oy,y,x,Nt,len,t;
	FOM	**fom,*sum,*S,*F,*T,*D,*C;
	MSD	msd;
	char	form[LEN],path[LEN];
	double	d,c,w,a,b;

	if (argc<6 || argc>9)
	Error("usage : oct_cmp_180 HiPic/ {y1 y2} Ox1 Ox2 Oy1 Oy2 {MSD/}");

	InitReadHiPic(argv[1],&hp);

	if (hp.Nt%2) (void)fputs("bad number of views (warning).\n",stderr);

	if (argc==6 || argc==7) {
	    y1=0; y2=hp.Ny-1; i=2;
	}
	else {
	    if ((y1=atoi(argv[2]))<0 ||
		(y2=atoi(argv[3]))>=hp.Ny || y1>y2)
		Error("bad range of slices.");

	    i=4;
	}
	Ny=y2-y1+1;
	if ((Ox1=atoi(argv[i  ]))<=(-hp.Nx) ||
	    (Ox2=atoi(argv[i+1]))>=  hp.Nx  || Ox1>Ox2 ||
	    (Oy1=atoi(argv[i+2]))<=(-   Ny) ||
	    (Oy2=atoi(argv[i+3]))>=     Ny  || Oy1>Oy2)
	    Error("bad range of offsets.");

	X=((Ox=Ox2-Ox1+1)>hp.Nx)?Ox:hp.Nx;
	Y=((Oy=Oy2-Oy1+1)>   Ny)?Oy:   Ny;
	if ((fom=(FOM **)malloc(sizeof(FOM *)*Y))==NULL ||
	    (*fom=(FOM *)malloc(sizeof(FOM)*Y*X))==NULL ||
	    (sum=(FOM *)malloc(sizeof(FOM)*Oy*Ox))==NULL ||
	    !InitMSD(&msd,hp.Nx,Ny,hp.Nx,Ny,Ox1,Oy1,Ox2,Oy2))
	    Error("memory allocation error.");

	for (y=1; y<Y; y++) fom[y]=fom[y-1]+X;

	S=sum;
	for (y=0; y<Oy; y++)
	for (x=0; x<Ox; x++) *(S++)=0.0;

	Nt=hp.Nt/2;
	if (argc==7 || argc==9) {
	    len=1; for (t=10; t<Nt; t*=10) ++len;
	    (void)sprintf(form,"%s/%%0%dd.tif",argv[argc-1],len);
	}
	for (t=0; t<Nt; t++) {
	    ReadHiPic(&hp,t+Nt);
	    for (y=y1; y<=y2; y++) {
		F=fom[y-y1]+hp.Nx; T=hp.T[y];
		for (x=0; x<hp.Nx; x++) *(--F)=(T[x]>0.0)?-log(T[x]):0.0;
	    }
	    ReadHiPic(&hp,t);
	    for (y=y1; y<=y2; y++) {
		F=hp.T[y-y1]; T=hp.T[y];
		for (x=0; x<hp.Nx; x++) *(F++)=(T[x]>0.0)?-log(T[x]):0.0;
	    }
	    CalcMSD(&msd,hp.T,fom);

	    d=(*(D=msd.D)); c=(*(C=msd.C)); x=Ox1; y=Oy1; S=sum;
	    for (Y=Oy1; Y<=Oy2; Y++) {
		F=fom[Y-Oy1];
		for (X=Ox1; X<=Ox2; X++) {
		    *(S++)+=(w=(*(F++)=(*(D++))));
		    if (w<d) {
			d=w; c=(*C); x=X; y=Y;
		    }
		    ++C;
		}
	    }
	    (void)printf("%d\t%d\t%d\t%le\t%le\n",t,x,y,d,c);

	    if (argc==7 || argc==9) {
		(void)sprintf(path,form,t);
		StoreImageFile_Float(path,Ox,Oy,fom,SIF_F_desc);
	    }
	}
	d=(*(S=sum)); x=Ox1; y=Oy1;
	for (Y=Oy1; Y<=Oy2; Y++)
	for (X=Ox1; X<=Ox2; X++)
	    if ((w=(*(S++)))<d) {
		d=w; x=X; y=Y;
	    }

	(void)fprintf(stderr,"%d\t%d\t%le\n",x,y,d/(double)Nt);

	TermMSD(&msd); free(sum); free(*fom); free(fom); TermReadHiPic(&hp);

	return 0;
}
