
#include <stdio.h>
#include <stdlib.h>

#define LEN	2048

int	main(int argc,char **argv)
{
	FILE	*f,*h;
	char	str[LEN];
	int	c,N,M,L,m1,m2,l,m,n;
	double	p;

	if (argc!=3) {
	    (void)fputs("usage : sg_f2h FRCT_SG.bin HRCT_SG.bin\n",stderr);
	    exit(1);
	}
	if (argv[1][0]=='-')
	    f=stdin;
	else
	    if ((f=fopen(argv[1],"rb"))==NULL) {
		(void)fprintf(stderr,"%s : file not found.\n",argv[1]); exit(1);
	    }

	if (fgets(str,LEN,f)==NULL || (c=sscanf(str,"%d %d %d",&N,&M,&L))<2
				   || N<=0 || M<=0 || (c==3 && L<=0)) {
	    (void)fputs("bad sinogram size.\n",stderr); exit(1);
	}
	if (M%2) (void)fputs("bad number of views (warning).\n",stderr);

#ifdef	REVERSE
	m1=M/2; m2=M;
#else
	m1=0; m2=M/2;
#endif
	if (argv[2][0]=='-')
	    h=stdout;
	else
	    if ((h=fopen(argv[2],"wb"))==NULL) {
		(void)fprintf(stderr,"%s : file not open.\n",argv[2]); exit(1);
	    }

	if (c==3)
	    (void)fprintf(h,"%d\t%d\t%d\n",N,m2-m1,L);
	else {
	    (void)fprintf(h,"%d\t%d\n",N,m2-m1); L=1;
	}
	for (l=0; l<L; l++)
	for (m=0; m<M; m++)
	for (n=0; n<N; n++) {
	    if (fread(&p,sizeof(p),1,f)!=1) {
		(void)fputs("sinogram read error.\n",stderr); exit(1);
	    }
	    if (m>=m1 && m<m2) (void)fwrite(&p,sizeof(p),1,h);
	}
	if (h!=stdout) (void)fclose(h);
	if (f!=stdin ) (void)fclose(f);

	return 0;
}
