
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "csi_f.h"
#include "rif_f.h"
#include "sif_f.h"

#ifdef	XT2XP
static double	Log(double d)
{
	return (d>0.0)?log(d):0.0;
}

#define COMMAND		"xt2xp_float"
#define ORG		"XT"
#define NEW		"XP"
#define FUNCTION	XT2XP_Float
#define CONVERSION(xt)	(-Log(xt))
#else
#define COMMAND		"xp2xt_float"
#define ORG		"XP"
#define NEW		"XT"
#define FUNCTION	XP2XT_Float
#define CONVERSION(xp)	exp(-(xp))
#endif

#define LEN	2048

static void	FUNCTION(char *org,char *new)
{
	int	bps,Nx,Ny,n,y,x;
	FOM	**fom;
	char	*id,str[8][LEN],*u_c,
		*u="using integer PV as is floating-point PV",
		*c="converting PV by TIFF image description tag";
	double	min,max,base,step;

	if ((bps=ReadImageFile_Float(org,&Nx,&Ny,&fom,&id))!=0) {
	    if (id!=NULL) {
		if ((n=sscanf(id,"%s %s %s %s %s %s %s %s",
				 str[0],str[1],str[2],str[3],
				 str[4],str[5],str[6],str[7]))==2 || n==6)
		    if (sscanf(str[n-2],"%lf",&min)!=1 ||
			sscanf(str[n-1],"%lf",&max)!=1 || min>=max)
			u_c=u;
		    else {
			u_c=c; base=min; step=(max-min)/(double)((1ULL<<bps)-1);
		    }
		else
		    u_c=((n!=3 && n!=4 && n!=8) ||
			 sscanf(str[n-2],"%lf",&base)!=1 ||
			 sscanf(str[n-1],"%lf",&step)!=1 || step<=0.0)?u:c;

		free(id);
	    }
	    else
		u_c=u;
#ifdef	U_C
	    (void)fprintf(stderr,"%s : %s (warning).\n",org,u_c);
#endif
	}
	else {
	    u_c=NULL; if (id!=NULL) free(id);
	}
	if (u_c!=c) {
	    base=0.0; step=1.0;
	}
	for (y=0; y<Ny; y++)
	for (x=0; x<Nx; x++) fom[y][x]=CONVERSION(base+step*fom[y][x]);

	StoreImageFile_Float(new,Nx,Ny,fom,SIF_F_desc);

	for (y=0; y<Ny; y++) free(fom[y]); free(fom);
}

int	main(int argc,char **argv)
{
	char	**paths,path[LEN];
	int	Nz,len,z;

	if (argc==3)
	    FUNCTION(argv[1],argv[2]);
	else if (argc==4) {
	    paths=CheckSliceImages_Float(argv[1],argv[2],NULL,NULL,&Nz,NULL);

	    for (len=0; argv[1][len]!='\0'; len++) ;

	    for (z=0; z<Nz; z++) {
		(void)sprintf(path,"%s/%s",argv[3],paths[z]+len+1);
		FUNCTION(paths[z],path);
		free(paths[z]);
	    }
	    free(paths);
	}
	else {
	    (void)fputs("usage : " COMMAND " " ORG ".tif " NEW ".tif\n"
			"        " COMMAND " " ORG "/ nameFile " NEW "/\n",
			stderr); exit(1);
	}
	return 0;
}
