
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "rhp.h"
#include "sif_f.h"

extern void	Error(char *msg);

int	main(int argc,char **argv)
{
	HiPic	hp;
	int	Ny,Nt,y,t,x,y0,Y,ny,dz,y1,y2,Dz;
	FOM	**fom,*T,f;
	double	s,a,s2,b,s1,rmv,RMV;
	FILE	*file;

	if (argc!=3 && argc!=4 && argc!=6)
	    Error("usage : hp_ta HiPic/ TA.tif {{y1 y2} SVC.txt}");

	InitReadHiPic(argv[1],&hp); Ny=hp.Ny; Nt=hp.Nt;

	if ((fom=(FOM **)malloc(sizeof(FOM *)*Ny))==NULL ||
	    (*fom=(FOM *)malloc(sizeof(FOM)*Ny*Nt))==NULL)
	    Error("memory allocation error.");

	for (y=1; y<Ny; y++) fom[y]=fom[y-1]+Nt;

	for (t=0; t<Nt; t++) {
	    ReadHiPic(&hp,t);

	    for (y=0; y<Ny; y++) {
		s=0.0;
		for (T=hp.T[y], x=0; x<hp.Nx; x++, T++) if (*T>0.0) s-=log(*T);
		fom[y][t]=s;
	    }
	}
	StoreImageFile_Float(argv[2],Nt,Ny,fom,SIF_F_desc);

	(void)puts(SIF_F_desc);

	TermReadHiPic(&hp);

	if (argc==4 || argc==6) {
	    if (Nt<2) Error("too few views.");

	    if (argc==4) {
		y0=0; Y=ny=Ny;
	    }
	    else
		if ((y0=atoi(argv[3]))<0 ||
		    (Y=atoi(argv[4])+1)>Ny ||
		    (ny=Y-y0)<=0) Error("bad slice range.");

	    if (argv[argc-1][0]=='-')
		file=stdout;
	    else
	    if ((file=fopen(argv[argc-1],"w"))==NULL) Error("file not open.");

	    for (dz=1-ny; dz<ny; dz++) {
		if (dz<0) {
		    y1=y0; y2=Y+dz;
		}
		else {
		    y1=y0+dz; y2=Y;
		}
		a=(double)dz/(double)(Nt-1); s2=0.0;
		for (y=y1; y<y2; y++) {
		    b=(double)y+0.5; s1=0.0;
		    for (t=0; t<Nt; t++) {
			f=fom[(int)floor(b-a*(double)t)][t]; s1+=f; s2+=(f*f);
		    }
		    s2-=(s1*s1/(double)Nt);
		}
		(void)fprintf(file,"%d\t%lf\n",
				   dz,rmv=sqrt(s2/(double)Nt/(double)(y2-y1)));

		if (dz==1-ny || rmv<RMV) {
		    Dz=dz; RMV=rmv;
		}
	    }
	    if (file!=stdout) (void)fclose(file);

	    (void)printf("%d\t%lf\n",Dz,RMV);
	}
	free(*fom); free(fom);

	return 0;
}
