
#include <stdio.h>
#include <stdlib.h>
#include "rif_f.h"
#include "cbp.h"
#include "sif_f.h"

extern void	Error(char *msg);

#define EPS	1e-9
#define DEG	3.14159265358979323846/180.0

int	main(int argc,char **argv)
{
	int	bps,N,M,m,n,y,x;
	FOM	**p_f;
	char	*id;
	double	min,max,dr,RC,B=0.0,S=1.0;
	Float	**p,**f;

	if (argc!=6) Error("usage : sg_f2tg SG.tif dr RC RA TG.tif");

	if ((bps=ReadImageFile_Float(argv[1],&N,&M,&p_f,&id))!=0)
	    if (id!=NULL && sscanf(id,"%lf %lf",&min,&max)==2 && min<max) {
		B=min; S=(max-min)/(double)((1ULL<<bps)-1);
#ifdef	U_C

#define WARNING(msg)	\
	(void)fprintf(stderr,"%s : " msg " (warning).\n",argv[1])

		WARNING("converting PV by TIFF image description tag");
	    }
	    else
		WARNING("using integer PV as is floating-point PV");
#else
	    }
#endif
	if (id!=NULL) free(id);

	if ((dr=atof(argv[2]))>(-EPS) && dr<EPS)
	    Error("bad detector interval.");

	if ((RC=atof(argv[3]))<=0.0 || RC>=(double)(N-1))
	    Error("bad rotation center (unit in detector interval).");

	if ((N>M && ((p_f=(FOM **)realloc(p_f,sizeof(FOM *)*N))==NULL ||
		     (p_f[M]=(FOM *)malloc(sizeof(FOM)*(N-M)*N))==NULL)) ||
	    (p=InitCBP(N,M))==NULL) Error("memory allocation error.");

	for (m=0; m<M; m++)
	for (n=0; n<N; n++) p[m][n]=B+S*p_f[m][n];

	f=CBP(dr,-RC,atof(argv[4])*DEG);

	for (y=0; y<N; y++) {
	    if (y>M) p_f[y]=p_f[y-1]+N;

	    for (x=0; x<N; x++) p_f[y][x]=f[y][x];
	}
	TermCBP();

	StoreImageFile_Float(argv[5],N,N,p_f,SIF_F_desc);
	(void)puts(SIF_F_desc);

	for (m=M-(N<=M); m>=0; m--) free(p_f[m]); free(p_f);

	return 0;
}
